Index: uspace/srv/ns/ns.c
===================================================================
--- uspace/srv/ns/ns.c	(revision 3636964a0c670d2ee2523425ef20a055d82a337d)
+++ uspace/srv/ns/ns.c	(revision 215abc165fc8eda817e4c859ba67ddcadb7c1e64)
@@ -36,90 +36,24 @@
  */
 
-
 #include <ipc/ipc.h>
+#include <ipc/services.h>
 #include <ipc/ns.h>
-#include <ipc/services.h>
+#include <unistd.h>
 #include <stdio.h>
-#include <bool.h>
-#include <unistd.h>
-#include <stdlib.h>
 #include <errno.h>
-#include <assert.h>
-#include <libadt/list.h>
-#include <libadt/hash_table.h>
-#include <sysinfo.h>
-#include <loader/loader.h>
+#include <as.h>
 #include <ddi.h>
-#include <as.h>
-
-#define NAME  "ns"
-
-#define NS_HASH_TABLE_CHAINS  20
-
-static int register_service(ipcarg_t service, ipcarg_t phone, ipc_call_t *call);
-static void connect_to_service(ipcarg_t service, ipc_call_t *call,
-    ipc_callid_t callid);
-
-void register_clonable(ipcarg_t service, ipcarg_t phone, ipc_call_t *call,
-    ipc_callid_t callid);
-void connect_to_clonable(ipcarg_t service, ipc_call_t *call,
-    ipc_callid_t callid);
-
-
-/* Static functions implementing NS hash table operations. */
-static hash_index_t ns_hash(unsigned long *key);
-static int ns_compare(unsigned long *key, hash_count_t keys, link_t *item);
-static void ns_remove(link_t *item);
-
-/** Operations for NS hash table. */
-static hash_table_operations_t ns_hash_table_ops = {
-	.hash = ns_hash,
-	.compare = ns_compare,
-	.remove_callback = ns_remove
-};
-
-/** NS hash table structure. */
-static hash_table_t ns_hash_table;
-
-/** NS hash table item. */
-typedef struct {
-	link_t link;
-	ipcarg_t service;        /**< Number of the service. */
-	ipcarg_t phone;          /**< Phone registered with the service. */
-	ipcarg_t in_phone_hash;  /**< Incoming phone hash. */
-} hashed_service_t;
-
-/** Pending connection structure. */
-typedef struct {
-	link_t link;
-	ipcarg_t service;        /**< Number of the service. */
-	ipc_callid_t callid;     /**< Call ID waiting for the connection */
-	ipcarg_t arg2;           /**< Second argument */
-	ipcarg_t arg3;           /**< Third argument */
-} pending_req_t;
-
-static link_t pending_req;
-
-/** Request for connection to a clonable service. */
-typedef struct {
-	link_t link;
-	ipcarg_t service;
-	ipc_call_t call;
-	ipc_callid_t callid;
-} cs_req_t;
-
-/** List of clonable-service connection requests. */
-static link_t cs_req;
+#include <event.h>
+#include <macros.h>
+#include "ns.h"
+#include "service.h"
+#include "clonable.h"
+#include "task.h"
 
 static void *clockaddr = NULL;
 static void *klogaddr = NULL;
 
-/** Return true if @a service is clonable. */
-static bool service_clonable(int service)
-{
-	return (service == SERVICE_LOAD);
-}
-
-static void get_as_area(ipc_callid_t callid, ipc_call_t *call, void *ph_addr, count_t pages, void **addr)
+static void get_as_area(ipc_callid_t callid, ipc_call_t *call, void *ph_addr,
+    size_t pages, void **addr)
 {
 	if (ph_addr == NULL) {
@@ -146,56 +80,38 @@
 }
 
-/** Process pending connection requests */
-static void process_pending_req()
-{
-	link_t *cur;
-	
-loop:
-	for (cur = pending_req.next; cur != &pending_req; cur = cur->next) {
-		pending_req_t *pr = list_get_instance(cur, pending_req_t, link);
-		
-		unsigned long keys[3] = {
-			pr->service,
-			0,
-			0
-		};
-		
-		link_t *link = hash_table_find(&ns_hash_table, keys);
-		if (!link)
-			continue;
-		
-		hashed_service_t *hs = hash_table_get_instance(link, hashed_service_t, link);
-		ipcarg_t retval = ipc_forward_fast(pr->callid, hs->phone,
-		    pr->arg2, pr->arg3, 0, IPC_FF_NONE);
-		
-		if (!(pr->callid & IPC_CALLID_NOTIFICATION))
-			ipc_answer_0(pr->callid, retval);
-		
-		list_remove(cur);
-		free(pr);
-		goto loop;
-	}
-}
-
 int main(int argc, char **argv)
 {
 	printf(NAME ": HelenOS IPC Naming Service\n");
 	
-	if (!hash_table_create(&ns_hash_table, NS_HASH_TABLE_CHAINS, 3,
-	    &ns_hash_table_ops)) {
-		printf(NAME ": No memory available for services\n");
-		return ENOMEM;
-	}
+	int rc = service_init();
+	if (rc != EOK)
+		return rc;
 	
-	list_initialize(&pending_req);
-	list_initialize(&cs_req);
+	rc = clonable_init();
+	if (rc != EOK)
+		return rc;
+	
+	rc = task_init();
+	if (rc != EOK)
+		return rc;
 	
 	printf(NAME ": Accepting connections\n");
+	
 	while (true) {
-		process_pending_req();
+		process_pending_conn();
+		process_pending_wait();
 		
 		ipc_call_t call;
 		ipc_callid_t callid = ipc_wait_for_call(&call);
+		
+		task_id_t id;
 		ipcarg_t retval;
+		
+		if (callid & IPC_CALLID_NOTIFICATION) {
+			id = (task_id_t)
+			    MERGE_LOUP32(IPC_GET_ARG2(call), IPC_GET_ARG3(call));
+			wait_notification((wait_type_t) IPC_GET_ARG1(call), id);
+			continue;
+		}
 		
 		switch (IPC_GET_METHOD(call)) {
@@ -203,8 +119,12 @@
 			switch (IPC_GET_ARG3(call)) {
 			case SERVICE_MEM_REALTIME:
-				get_as_area(callid, &call, sysinfo_value("clock.faddr"), 1, &clockaddr);
+				get_as_area(callid, &call,
+				    (void *) sysinfo_value("clock.faddr"),
+				    1, &clockaddr);
 				break;
 			case SERVICE_MEM_KLOG:
-				get_as_area(callid, &call, sysinfo_value("klog.faddr"), sysinfo_value("klog.pages"), &klogaddr);
+				get_as_area(callid, &call,
+				    (void *) sysinfo_value("klog.faddr"),
+				    sysinfo_value("klog.pages"), &klogaddr);
 				break;
 			default:
@@ -242,4 +162,12 @@
 			}
 			break;
+		case NS_PING:
+			retval = EOK;
+			break;
+		case NS_TASK_WAIT:
+			id = (task_id_t)
+			    MERGE_LOUP32(IPC_GET_ARG1(call), IPC_GET_ARG2(call));
+			wait_for_task(id, &call, callid);
+			continue;
 		default:
 			retval = ENOENT;
@@ -255,211 +183,4 @@
 }
 
-/** Register service.
- *
- * @param service Service to be registered.
- * @param phone   Phone to be used for connections to the service.
- * @param call    Pointer to call structure.
- *
- * @return Zero on success or a value from @ref errno.h.
- *
- */
-int register_service(ipcarg_t service, ipcarg_t phone, ipc_call_t *call)
-{
-	unsigned long keys[3] = {
-		service,
-		call->in_phone_hash,
-		0
-	};
-	
-	if (hash_table_find(&ns_hash_table, keys))
-		return EEXISTS;
-	
-	hashed_service_t *hs = (hashed_service_t *) malloc(sizeof(hashed_service_t));
-	if (!hs)
-		return ENOMEM;
-	
-	link_initialize(&hs->link);
-	hs->service = service;
-	hs->phone = phone;
-	hs->in_phone_hash = call->in_phone_hash;
-	hash_table_insert(&ns_hash_table, keys, &hs->link);
-	
-	return 0;
-}
-
-/** Connect client to service.
- *
- * @param service Service to be connected to.
- * @param call    Pointer to call structure.
- * @param callid  Call ID of the request.
- *
- * @return Zero on success or a value from @ref errno.h.
- *
- */
-void connect_to_service(ipcarg_t service, ipc_call_t *call, ipc_callid_t callid)
-{
-	ipcarg_t retval;
-	unsigned long keys[3] = {
-		service,
-		0,
-		0
-	};
-	
-	link_t *link = hash_table_find(&ns_hash_table, keys);
-	if (!link) {
-		if (IPC_GET_ARG4(*call) & IPC_FLAG_BLOCKING) {
-			/* Blocking connection, add to pending list */
-			pending_req_t *pr = (pending_req_t *) malloc(sizeof(pending_req_t));
-			if (!pr) {
-				retval = ENOMEM;
-				goto out;
-			}
-			
-			pr->service = service;
-			pr->callid = callid;
-			pr->arg2 = IPC_GET_ARG2(*call);
-			pr->arg3 = IPC_GET_ARG3(*call);
-			list_append(&pr->link, &pending_req);
-			return;
-		}
-		retval = ENOENT;
-		goto out;
-	}
-	
-	hashed_service_t *hs = hash_table_get_instance(link, hashed_service_t, link);
-	retval = ipc_forward_fast(callid, hs->phone, IPC_GET_ARG2(*call),
-	    IPC_GET_ARG3(*call), 0, IPC_FF_NONE);
-out:
-	if (!(callid & IPC_CALLID_NOTIFICATION))
-		ipc_answer_0(callid, retval);
-}
-
-/** Register clonable service.
- *
- * @param service Service to be registered.
- * @param phone   Phone to be used for connections to the service.
- * @param call    Pointer to call structure.
- *
- */
-void register_clonable(ipcarg_t service, ipcarg_t phone, ipc_call_t *call,
-    ipc_callid_t callid)
-{
-	if (list_empty(&cs_req)) {
-		/* There was no pending connection request. */
-		printf(NAME ": Unexpected clonable server.\n");
-		ipc_answer_0(callid, EBUSY);
-		return;
-	}
-	
-	cs_req_t *csr = list_get_instance(cs_req.next, cs_req_t, link);
-	list_remove(&csr->link);
-	
-	/* Currently we can only handle a single type of clonable service. */
-	assert(csr->service == SERVICE_LOAD);
-	
-	ipc_answer_0(callid, EOK);
-	
-	int rc = ipc_forward_fast(csr->callid, phone, IPC_GET_ARG2(csr->call),
-		IPC_GET_ARG3(csr->call), 0, IPC_FF_NONE);
-
-	free(csr);
-	ipc_hangup(phone);
-}
-
-/** Connect client to clonable service.
- *
- * @param service Service to be connected to.
- * @param call    Pointer to call structure.
- * @param callid  Call ID of the request.
- *
- * @return Zero on success or a value from @ref errno.h.
- *
- */
-void connect_to_clonable(ipcarg_t service, ipc_call_t *call,
-    ipc_callid_t callid)
-{
-	assert(service == SERVICE_LOAD);
-	
-	cs_req_t *csr = malloc(sizeof(cs_req_t));
-	if (csr == NULL) {
-		ipc_answer_0(callid, ENOMEM);
-		return;
-	}
-	
-	/* Spawn a loader. */
-	int rc = loader_spawn("loader");
-	
-	if (rc < 0) {
-		free(csr);
-		ipc_answer_0(callid, rc);
-		return;
-	}
-	
-	csr->service = service;
-	csr->call = *call;
-	csr->callid = callid;
-	
-	/*
-	 * We can forward the call only after the server we spawned connects
-	 * to us. Meanwhile we might need to service more connection requests.
-	 * Thus we store the call in a queue.
-	 */
-	list_append(&csr->link, &cs_req);
-}
-
-/** Compute hash index into NS hash table.
- *
- * @param key Pointer keys. However, only the first key (i.e. service number)
- *            is used to compute the hash index.
- *
- * @return Hash index corresponding to key[0].
- *
- */
-hash_index_t ns_hash(unsigned long *key)
-{
-	assert(key);
-	return (*key % NS_HASH_TABLE_CHAINS);
-}
-
-/** Compare a key with hashed item.
- *
- * This compare function always ignores the third key.
- * It exists only to make it possible to remove records
- * originating from connection with key[1] in_phone_hash
- * value. Note that this is close to being classified
- * as a nasty hack.
- *
- * @param key  Array of keys.
- * @param keys Must be lesser or equal to 3.
- * @param item Pointer to a hash table item.
- *
- * @return Non-zero if the key matches the item, zero otherwise.
- *
- */
-int ns_compare(unsigned long key[], hash_count_t keys, link_t *item)
-{
-	assert(key);
-	assert(keys <= 3);
-	assert(item);
-	
-	hashed_service_t *hs = hash_table_get_instance(item, hashed_service_t, link);
-	
-	if (keys == 2)
-		return key[1] == hs->in_phone_hash;
-	else
-		return key[0] == hs->service;
-}
-
-/** Perform actions after removal of item from the hash table.
- *
- * @param item Item that was removed from the hash table.
- *
- */
-void ns_remove(link_t *item)
-{
-	assert(item);
-	free(hash_table_get_instance(item, hashed_service_t, link));
-}
-
 /**
  * @}